2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
5 USAGE
="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
22 prefix
=$
(git rev-parse
--show-prefix) ||
exit 1
25 TMP
="$GIT_DIR/.git-stash.$$"
26 TMPindex
=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
31 if git config
--get-colorbool color.interactive
; then
32 help_color
="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color
="$(git config --get-color '' reset)"
40 git diff-index
--quiet --cached HEAD
--ignore-submodules -- "$@" &&
41 git diff-files
--quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" ||
test -z "$(untracked_files "$@
")")
53 excl_opt
=--exclude-standard
54 test "$untracked" = "all" && excl_opt
=
55 git ls-files
-o $z $excl_opt -- "$@"
58 prepare_fallback_ident
() {
59 if ! git
-c user.useconfigonly
=yes var GIT_COMMITTER_IDENT
>/dev
/null
2>&1
61 GIT_AUTHOR_NAME
="git stash"
62 GIT_AUTHOR_EMAIL
=git@stash
63 GIT_COMMITTER_NAME
="git stash"
64 GIT_COMMITTER_EMAIL
=git@stash
65 export GIT_AUTHOR_NAME
66 export GIT_AUTHOR_EMAIL
67 export GIT_COMMITTER_NAME
68 export GIT_COMMITTER_EMAIL
75 die
"$(gettext "git stash
clear with parameters is unimplemented
")"
77 if current
=$
(git rev-parse
--verify --quiet $ref_stash)
79 git update-ref
-d $ref_stash $current
87 if test -n "$GIT_QUIET"
95 if test -n "$GIT_QUIET"
107 prepare_fallback_ident
116 stash_msg
=${1?"BUG: create_stash () -m requires an argument"}
122 stash_msg
=${1#--message=}
124 -u|
--include-untracked)
126 untracked
=${1?"BUG: create_stash () -u requires an argument"}
136 git update-index
-q --refresh
137 if maybe_quiet no_changes
"$@"
142 # state of the base commit
143 if b_commit
=$
(maybe_quiet
--keep-stdout git rev-parse
--verify HEAD
)
145 head=$
(git rev-list
--oneline -n 1 HEAD
--)
146 elif test -n "$GIT_QUIET"
150 die
"$(gettext "You
do not have the initial commit yet
")"
153 if branch
=$
(git symbolic-ref
-q HEAD
)
155 branch
=${branch#refs/heads/}
159 msg
=$
(printf '%s: %s' "$branch" "$head")
162 i_tree
=$
(git write-tree
) &&
163 i_commit
=$
(printf 'index on %s\n' "$msg" |
164 git commit-tree
$i_tree -p $b_commit) ||
165 die
"$(gettext "Cannot save the current index state
")"
167 if test -n "$untracked"
169 # Untracked files are stored by themselves in a parentless commit, for
170 # ease of unpacking later.
172 untracked_files
-z "$@" |
(
173 GIT_INDEX_FILE
="$TMPindex" &&
174 export GIT_INDEX_FILE
&&
176 git update-index
-z --add --remove --stdin &&
177 u_tree
=$
(git write-tree
) &&
178 printf 'untracked files on %s\n' "$msg" | git commit-tree
$u_tree &&
180 ) ) || die
"$(gettext "Cannot save the untracked files
")"
182 untracked_commit_option
="-p $u_commit";
184 untracked_commit_option
=
187 if test -z "$patch_mode"
190 # state of the working tree
192 git read-tree
--index-output="$TMPindex" -m $i_tree &&
193 GIT_INDEX_FILE
="$TMPindex" &&
194 export GIT_INDEX_FILE
&&
195 git diff-index
--name-only -z HEAD
-- "$@" >"$TMP-stagenames" &&
196 git update-index
--ignore-skip-worktree-entries \
197 -z --add --remove --stdin <"$TMP-stagenames" &&
201 die
"$(gettext "Cannot save the current worktree state
")"
205 rm -f "$TMP-index" &&
206 GIT_INDEX_FILE
="$TMP-index" git read-tree HEAD
&&
208 # find out what the user wants
209 GIT_INDEX_FILE
="$TMP-index" \
210 git add
--legacy-stash-p -- "$@" &&
212 # state of the working tree
213 w_tree
=$
(GIT_INDEX_FILE
="$TMP-index" git write-tree
) ||
214 die
"$(gettext "Cannot save the current worktree state
")"
216 git diff-tree
-p HEAD
$w_tree -- >"$TMP-patch" &&
217 test -s "$TMP-patch" ||
218 die
"$(gettext "No changes selected
")"
220 rm -f "$TMP-index" ||
221 die
"$(gettext "Cannot remove temporary index
(can
't happen)")"
226 if test -z "$stash_msg"
228 stash_msg=$(printf 'WIP on
%s
' "$msg")
230 stash_msg=$(printf 'On
%s
: %s
' "$branch" "$stash_msg")
232 w_commit=$(printf '%s
\n' "$stash_msg" |
233 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
234 die "$(gettext "Cannot record working tree state")"
249 stash_msg=${1#--message=}
261 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
264 if test -z "$stash_msg"
266 stash_msg="Created via \"git stash store\"."
269 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
271 test $ret != 0 && test -z "$quiet" &&
272 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
292 # only default to keep if we don't already have an override
293 test -z "$keep_index" && keep_index
=t
298 -u|
--include-untracked)
306 test -z ${1+x} && usage
313 stash_msg
=${1#--message=}
324 eval_gettextln
"error: unknown option for 'stash push': \$option"
334 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@
")"
336 if test -n "$patch_mode" && test -n "$untracked"
338 die
"$(gettext "Can
't use --patch and --include-untracked or --all at the same time")"
341 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
343 git update-index -q --refresh
344 if maybe_quiet no_changes "$@"
346 say "$(gettext "No local changes to save")"
350 git reflog exists $ref_stash ||
351 clear_stash || die "$(gettext "Cannot initialize stash")"
353 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
354 store_stash -m "$stash_msg" -q $w_commit ||
355 die "$(gettext "Cannot save the current status")"
356 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
358 if test -z "$patch_mode"
360 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
361 if test -n "$untracked" && test $# = 0
363 git clean --force --quiet -d $CLEAN_X_OPTION
368 test -z "$untracked" && UPDATE_OPTION="-u" || UPDATE_OPTION=
369 test "$untracked" = "all" && FORCE_OPTION="--force" || FORCE_OPTION=
370 git add $UPDATE_OPTION $FORCE_OPTION -- "$@"
371 git diff-index -p --cached --binary HEAD -- "$@" |
374 git reset --hard -q --no-recurse-submodules
377 if test "$keep_index" = "t" && test -n "$i_tree"
379 git read-tree --reset $i_tree
380 git ls-files -z --modified -- "$@" |
381 git checkout-index -z --force --stdin
384 git apply -R < "$TMP-patch" ||
385 die "$(gettext "Cannot remove worktree changes")"
387 if test "$keep_index" != "t"
407 # pass all options through to push_stash
408 push_options="$push_options $1"
419 if test -z "$stash_msg"
421 push_stash $push_options
423 push_stash $push_options -m "$stash_msg"
428 git rev-parse --verify --quiet $ref_stash >/dev/null
432 have_stash || return 0
433 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
437 ALLOW_UNKNOWN_FLAGS=t
438 assert_stash_like "$@"
442 if test "$(git config --bool stash.showStat || echo true)" = "true"
447 if test "$(git config --bool stash.showPatch || echo false)" = "true"
449 FLAGS=${FLAGS}${FLAGS:+ }-p
458 git diff ${FLAGS} $b_commit $w_commit
467 # Parses the remaining options looking for flags and
468 # at most one revision defaulting to ${ref_stash}@{0}
471 # Derives related tree and commit objects from the
472 # revision, if one is found.
474 # stash records the work tree, and is a merge between the
475 # base commit (first parent) and the index tree (second parent).
477 # REV is set to the symbolic version of the specified stash-like commit
478 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
479 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
480 # s is set to the SHA1 of the stash commit
481 # w_commit is set to the commit containing the working tree
482 # b_commit is set to the base commit
483 # i_commit is set to the commit containing the index tree
484 # u_commit is set to the commit containing the untracked files tree
485 # w_tree is set to the working tree
486 # b_tree is set to the base tree
487 # i_tree is set to the index tree
488 # u_tree is set to the untracked files tree
490 # GIT_QUIET is set to t if -q is specified
491 # INDEX_OPTION is set to --index if --index is specified.
492 # FLAGS is set to the remaining flags (if allowed)
495 # * too many revisions specified
496 # * no revision is specified and there is no stash stack
497 # * a revision is specified which cannot be resolve to a SHA1
498 # * a non-existent stash reference is specified
499 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
502 parse_flags_and_rev()
504 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
535 test "$ALLOW_UNKNOWN_FLAGS" = t ||
536 die "$(eval_gettext "unknown option: \$opt")"
537 FLAGS="${FLAGS}${FLAGS:+ }$opt"
540 REV="${REV}${REV:+ }'$opt'"
549 have_stash || die "$(gettext "No stash entries found.")"
550 set -- ${ref_stash}@{0}
556 die "$(eval_gettext "Too many revisions specified: \$REV")"
565 set -- "${ref_stash}@{$1}"
569 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
571 die "$(eval_gettext "\$reference is not a valid reference")"
574 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
575 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
583 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
586 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
587 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
592 parse_flags_and_rev "$@"
593 test -n "$IS_STASH_LIKE"
596 assert_stash_like() {
597 is_stash_like "$@" || {
599 die "$(eval_gettext "'\
$args' is not a stash-like commit")"
604 is_stash_like "$@" && test -n "$IS_STASH_REF"
608 is_stash_ref "$@" || {
610 die "$(eval_gettext "'\
$args' is not a stash reference")"
616 assert_stash_like "$@"
618 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
620 # current index state
621 c_tree=$(git write-tree) ||
622 die "$(gettext "Cannot apply a stash in the middle of a merge")"
624 unstashed_index_tree=
625 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
626 test "$c_tree" != "$i_tree"
628 git diff-tree --binary $s^2^..$s^2 | git apply --cached
630 die "$(gettext "Conflicts in index. Try without --index.")"
631 unstashed_index_tree=$(git write-tree) ||
632 die "$(gettext "Could not save index tree")"
638 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
639 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
641 die "$(gettext "Could not restore untracked files from stash entry")"
645 GITHEAD_$w_tree='Stashed changes
' &&
646 GITHEAD_$c_tree='Updated upstream
' &&
647 GITHEAD_$b_tree='Version stash was based on
' &&
648 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
651 if test -n "$GIT_QUIET"
653 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
655 if git merge-recursive $b_tree -- $c_tree $w_tree
658 if test -n "$unstashed_index_tree"
660 git read-tree "$unstashed_index_tree"
663 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
664 git read-tree --reset $c_tree &&
665 git update-index --add --stdin <"$a" ||
666 die "$(gettext "Cannot unstage modified files")"
670 if test -n "$GIT_QUIET"
672 squelch='>/dev
/null
2>&1'
674 (cd "$START_DIR" && eval "git status $squelch") || :
676 # Merge conflict; keep the exit status from merge-recursive
679 if test -n "$INDEX_OPTION"
681 gettextln "Index was not unstashed." >&2
688 assert_stash_ref "$@"
695 say "$(gettext "The stash entry is kept in case you need it again.")"
701 assert_stash_ref "$@"
703 git reflog delete --updateref --rewrite "${REV}" &&
704 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
705 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
707 # clear_stash if we just dropped the last stash entry
708 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
713 test -n "$1" || die "$(gettext "No branch name specified")"
718 assert_stash_like "$@"
720 git checkout -b $branch $REV^ &&
721 apply_stash "$@" && {
722 test -z "$IS_STASH_REF" || drop_stash "$@"
726 test "$1" = "-p" && set "push" "$@"
728 PARSE_CACHE='--not-parsed'
729 # The default command is "push" if nothing but options are given
736 *) seen_non_option=t; break ;;
740 test -n "$seen_non_option" || set "push" "$@"
770 create_stash -m "$*" && echo "$w_commit"
792 say "$(gettext "(To restore them type \"git stash apply\")")"